# -*- coding: utf-8 -*-
##
##
## This file is part of Indico.
## Copyright (C) 2002 - 2014 European Organization for Nuclear Research (CERN).
##
## Indico is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License as
## published by the Free Software Foundation; either version 3 of the
## License, or (at your option) any later version.
##
## Indico is distributed in the hope that it will be useful, but
## WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
## General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with Indico;if not, see <http://www.gnu.org/licenses/>.

import MaKaC.webinterface.pages.conferences as conferences
import MaKaC.webinterface.pages.registrationForm as registrationForm
from MaKaC.webinterface import wcomponents
from xml.sax.saxutils import quoteattr
from indico.core import config as Configuration
from MaKaC.webinterface import urlHandlers
import MaKaC
from MaKaC.i18n import _


from MaKaC.plugins.EPayment.payWay import MODULE_ID
from MaKaC.plugins.EPayment.payWay.webinterface.wcomponents import WTemplated
from MaKaC.plugins.EPayment.payWay.webinterface import urlHandlers as localUrlHandlers



class WPConfModifEPaymentPayWayBase(registrationForm.WPConfModifRegFormBase):

    def _createTabCtrl( self ):
        self._tabCtrl = wcomponents.TabControl()
        self._tabMain = self._tabCtrl.newTab( "main", _("Main"), \
                localUrlHandlers.UHConfModifEPaymentPayWay.getURL( self._conf ) )
        wf = self._rh.getWebFactory()
        if wf:
            wf.customiseTabCtrl( self._tabCtrl )
        self._setActiveTab()

    def _setActiveTab( self ):
        pass

    def _setActiveSideMenuItem(self):
        self._regFormMenuItem.setActive(True)

    def _getPageContent( self, params ):
        self._createTabCtrl()
        banner = wcomponents.WEpaymentBannerModif(self._conf.getModPay().getPayModByTag(MODULE_ID), self._conf).getHTML()
        html = wcomponents.WTabControl( self._tabCtrl, self._getAW() ).getHTML( self._getTabContent( params ) )
        return banner+html

    def _getTabContent( self, params ):
        return "nothing"

class WPConfModifEPaymentPayWay( WPConfModifEPaymentPayWayBase ):

    def _getTabContent( self, params ):
        wc = WConfModifEPaymentPayWay(self._conf)
        p = {
             'dataModificationURL': quoteattr(str(localUrlHandlers.UHConfModifEPaymentPayWayDataModif.getURL( self._conf )))
            }
        return wc.getHTML(p)

class WConfModifEPaymentPayWay( WTemplated ):

    def __init__( self, conference ):
        self._conf = conference

    def getVars( self ):
        vars = WTemplated.getVars(self)
        modPayWay = self._conf.getModPay().getPayModByTag(MODULE_ID)
        vars["title"] = modPayWay.getTitle()
        vars["url"] = modPayWay.getUrl()
        vars["business"] =  modPayWay.getBusiness()
        return vars

class WPConfModifEPaymentPayWayDataModif( WPConfModifEPaymentPayWayBase ):

    def _getTabContent( self, params ):
        wc = WConfModifEPaymentPayWayDataModif(self._conf)
        p = {'postURL': quoteattr(str(localUrlHandlers.UHConfModifEPaymentPayWayPerformDataModif.getURL( self._conf )))
            }
        return wc.getHTML(p)

class WConfModifEPaymentPayWayDataModif( WTemplated ):

    def __init__( self, conference ):
        self._conf = conference

    def getVars( self ):
        vars = WTemplated.getVars(self)
        modPayWay = self._conf.getModPay().getPayModByTag(MODULE_ID)
        vars["title"] = modPayWay.getTitle()
        vars["url"] = modPayWay.getUrl()
        vars["business"] =  modPayWay.getBusiness()
        return vars

class WPconfirmEPaymentPayWay( conferences.WPConferenceDefaultDisplayBase ):
    #navigationEntry = navigation.NERegistrationFormDisplay

    def __init__(self, rh, conf, reg):
        conferences.WPConferenceDefaultDisplayBase.__init__(self, rh, conf)
        self._registrant=reg


    def _getBody( self, params ):
        wc = WconfirmEPaymentPayWay(self._conf, self._registrant)
        return wc.getHTML()

    def _defineSectionMenu( self ):
        conferences.WPConferenceDefaultDisplayBase._defineSectionMenu(self)
        self._sectionMenu.setCurrentItem(self._regFormOpt)


class WconfirmEPaymentPayWay( WTemplated ):
    def __init__( self,configuration, registrant):
        self._registrant = registrant
        self._conf = configuration

    def getVars( self ):
        vars = WTemplated.getVars(self)
        vars["message"] = "Thank you for the payment!<br/> You have used PayWay"
        vars["trinfo"]="%s:%s"%(self._registrant.getFirstName(),self._registrant.getSurName())
        return vars

class WPCancelEPaymentPayWay( conferences.WPConferenceDefaultDisplayBase ):
    #navigationEntry = navigation.NERegistrationFormDisplay

    def __init__(self, rh, conf, reg):
        conferences.WPConferenceDefaultDisplayBase.__init__(self, rh, conf)
        self._registrant=reg

    def _getBody( self, params ):
        wc = WCancelEPaymentPayWay( self._conf,self._registrant )
        return wc.getHTML()

    def _defineSectionMenu( self ):
        conferences.WPConferenceDefaultDisplayBase._defineSectionMenu(self)
        self._sectionMenu.setCurrentItem(self._regFormOpt)

class WCancelEPaymentPayWay( WTemplated ):
    def __init__( self, conference,reg ):
        self._conf = conference
        self._registrant=reg

    def getVars( self ):
        vars = WTemplated.getVars(self)
        vars["message"] = "You have cancelled your transaction.\nPlease check your email in order to complete your PayWay transaction."
        vars["messagedetailPayment"]="%s:%s"%(self._registrant.getFirstName(),self._registrant.getSurName())
        return vars
